Package: lpcde
Type: Package
Title: Boundary Adaptive Local Polynomial Conditional Density Estimator
Version: 0.1.5
Authors@R: person(given = "Rajita",
           family = "Chandak",
           role = c("aut", "cre"),
           email = "rajita.chandak@epfl.ch" )
Maintainer: Rajita Chandak <rajita.chandak@epfl.ch>
Description: Tools for estimation and inference of conditional densities, derivatives and functions. This is the companion software for Cattaneo, Chandak, Jansson and Ma (2024) <doi:10.3150/23-BEJ1711>.
Depends: R (>= 3.3.0)
License: MIT + file LICENSE
Encoding: UTF-8
SystemRequirements: GNU make
RoxygenNote: 7.3.2
Imports: Rcpp (>= 0.12.8), ggplot2, purrr, MASS, mvtnorm, combinat,
        Matrix, Rdpack, stats
RdMacros: Rdpack
LinkingTo: Rcpp, RcppArmadillo
Suggests: testthat (>= 3.0.0), covr
Config/testthat/edition: 3
NeedsCompilation: yes
Packaged: 2024-11-14 09:24:15 UTC; rajitachandak
Author: Rajita Chandak [aut, cre]
Repository: CRAN
Date/Publication: 2024-11-14 10:20:02 UTC
Built: R 4.4.2; x86_64-apple-darwin19.6.0; 2024-12-13 04:22:35 UTC; unix

library("lpcde")

set.seed(42)
n=1000
x_data = matrix(rnorm(1*n, mean=0, sd=1), ncol=1)
y_data = matrix(rnorm(n, mean=0, sd=1))
y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

#bw estimation
model1 = lpbwcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, bw_type = "imse-rot")
summary(model1)

# density estimation
model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, bw=model1$BW[,2])
summary(model2)

# non-negative and integrating to 1 density estimation
model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, bw=model1$BW[,2], nonneg=TRUE, normalize=TRUE)
summary(model2)

#bw estimation
model1 = lpbwcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, bw_type = "mse-rot")
summary(model1)

# density estimation
model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, bw=model1$BW[,2])
summary(model2)

set.seed(42)
n=1000
x_data = matrix(rnorm(2*n, mean=0, sd=1), ncol=2)
y_data = matrix(rnorm(n, mean=0, sd=1))
y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

#bw estimation
model1 = lpbwcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=matrix(c(0, 0), ncol=2), bw_type="imse-rot")
summary(model1)

# density estimation
model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=matrix(c(0, 0), ncol=2), bw=model1$BW[,2])
summary(model2)

#bw estimation
model1 = lpbwcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=matrix(c(0, 0), ncol=2), bw_type="mse-rot")
summary(model1)

# density estimation
model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=matrix(c(0, 0), ncol=2), bw=model1$BW[,2])
summary(model2)

test_that("lpbwcde default output", {
  set.seed(42)
  n=100
  x_data = matrix(rnorm(1*n, mean=0, sd=1), ncol=1)
  y_data = matrix(rnorm(n, mean=0, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

 #bw estimation
  model1 = lpbwcde(x_data=x_data, y_data=y_data, x=0, bw_type = "imse-rot")
  print(model1)
  summary(model1)
  coef(model1)
  expect_equal(model1$opt$ng, 19)

  model1 = lpbwcde(x_data=x_data, y_data=y_data, x=0, bw_type = "mse-rot")
  expect_equal(model1$opt$bw_type, "mse-rot")
})

test_that("lpbwcde multivariate default output", {
  set.seed(42)
  n=100
  x_data = matrix(rnorm(2*n, mean=0, sd=1), ncol=2)
  y_data = matrix(rnorm(n, mean=0, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))
#bw estimation
  model1 = lpbwcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=matrix(c(0, 0), ncol=2), bw_type="imse-rot")
  summary(model1)
  expect_equal(model1$opt$bw_type, "imse-rot")
})

test_that("lpbwcde default output", {
  set.seed(42)
  n=100
  x_data = matrix(rnorm(1*n, mean=0, sd=1), ncol=1)
  y_data = matrix(rnorm(n, mean=0, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

#bw estimation
  model1 = lpbwcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, mu=0, p=3, bw_type = "imse-rot")
  print(model1)
  summary(model1)
  coef(model1)
  expect_equal(model1$opt$bw_type, "imse-rot")
})

test_that("polynomial vector generator works", {
  expect_equal(mvec(2, 1), 2)
})

test_that("polynomial vector", {
  expect_equal(poly_base(2, 1), matrix(c(1, 2), nrow=1))
})

test_that("multivariate polynomial vector", {
  expect_equal(poly_base(c(1, 2), 1), c(1, 1, 2))
})

test_that("basis vector", {
  expect_equal(basis_vec(5, 2, 1), matrix(c(0, 1, 0)))
})

test_that("multivariate basis vector", {
  expect_equal(basis_vec(c(1, 2), 1, 1), matrix(c(0, 1, 1)))
})

test_that("uniform kernel", {
  expect_equal(kernel_eval(0.5, "uniform"), 0.5)
})

test_that("triangular kernel", {
  expect_equal(kernel_eval(0.5, "triangular"), 0.5)
})

test_that("epanechnikov kernel", {
  expect_equal(kernel_eval(0.5, "epanechnikov"), 0.5625)
})

test_that("matrix inv fn", {
  expect_equal(check_inv(diag(3))[1], TRUE)
})

test_that("lpcde default output", {
  set.seed(42)
  n=100
  x_data = matrix(rnorm(1*n, mean=0, sd=1), ncol=1)
  y_data = matrix(rnorm(n, mean=0, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

# density estimation
  model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, bw=1.8)
  print(model2)
  confint(model2)
  coef(model2)
  vcov(model2)
  plot(model2)
  summary(model2, CIuniform=TRUE)
  confint(model2, CIuniform = TRUE)
  expect_equal(model2$opt$bw_type, "user provided")
  expect_equal(model2$opt$p, 2)
  expect_equal(model2$opt$q, 1)
  expect_equal(model2$opt$mu, 1)
  expect_equal(model2$opt$nu, 0)
  expect_equal(model2$opt$kernel, "epanechnikov")
  expect_equal(model2$opt$p_RBC, 3)
  expect_equal(model2$opt$q_RBC, 2)
})

test_that("lpcde modified output", {
  set.seed(42)
  n=100
  x_data = matrix(rnorm(1*n, mean=0, sd=1), ncol=1)
  y_data = matrix(rnorm(n, mean=0, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

# density estimation
  model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, mu=0, p=3, bw_type="imse-rot")
  summary(model2)
  expect_equal(model2$opt$bw_type, "imse-rot")
  expect_equal(model2$opt$p, 3)
  expect_equal(model2$opt$q, 1)
  expect_equal(model2$opt$mu, 0)
  expect_equal(model2$opt$nu, 0)
  expect_equal(model2$opt$kernel, "epanechnikov")
  expect_equal(model2$opt$p_RBC, 4)
  expect_equal(model2$opt$q_RBC, 2)
})


test_that("error checking", {
  set.seed(42)
  n=100
  x_data = matrix(rnorm(1*n, mean=0, sd=1), ncol=1)
  y_data = matrix(rnorm(n, mean=0, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

# density estimation
#  model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, p=2, q=1, p_RBC=2, q_RBC=1, bw=1.8)
#  expect_equal(model2$opt$p, model2$opt$p_RBC)
#  expect_equal(model2$opt$q, model2$opt$q_RBC)

  model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, kernel_type="triangular", bw=1.8, cov_flag="diag")
  expect_equal(model2$opt$kernel, "triangular")
  expect_equal(model2$opt$cov_flag, "diag")

  model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, kernel_type="triangular", bw=1.8, cov_flag="off")
  expect_equal(model2$CovMat$CovMat, NA)
  expect_equal(model2$CovMat$CovMat_RBC, NA)
})

test_that("lpcde multivariate output", {
  set.seed(42)
  n=100
  x_data = matrix(rnorm(2*n, mean=0, sd=1), ncol=2)
  y_data = matrix(rnorm(n, mean=0, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))

# density estimation
  model2 = lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=matrix(c(0, 0), ncol=2), bw_type="imse-rot")
  summary(model2, CIuniform=TRUE)
  expect_equal(model2$opt$p, 2)
  expect_equal(model2$opt$q, 1)
  expect_equal(model2$opt$mu, 1)
  expect_equal(model2$opt$nu, 0)
  expect_equal(model2$opt$kernel, "epanechnikov")
  expect_equal(model2$opt$p_RBC, 3)
  expect_equal(model2$opt$q_RBC, 2)
})

test_that("Properties of pdf estimator", {
  #Setting up simulation
  set.seed(30)
  n=100
  x_data = matrix(rnorm(n, mean=0, sd=1))
  y_data = matrix(rnorm(n, mean=x_data, sd=1))
  y_grid = stats::quantile(y_data, seq(from=0.1, to=0.9, by=0.1))
  #Regularized density estimation
  model_reg = lpcde::lpcde(x_data=x_data, y_data=y_data, y_grid=y_grid, x=0, bw=1, nonneg=TRUE, normalize=TRUE)

  #check integration to 1
  grid_diff = c(diff(y_grid), diff(utils::tail(y_grid, 2)))
  c = sum(model_reg$Estimate[, 3]*grid_diff)
  expect_equal(1, c)

  #check nonegativity
  a_nng = any(model_reg$Estimate[,3]<0)
  expect_equal(a_nng, FALSE)

  #check all probabilities are less than 1
  expect_equal(all(model_reg$Estimate[,3]<1), TRUE)
})

test_that("sx matrix", {
  sx = S_x(as.matrix(c(1, 2, 3)), 1, "uniform")
  sol = matrix(c(0.5, 0.5, 0.5, 0.5), nrow=2)
  expect_equal(sx, sol)
})

test_that("cx matrix", {
  sx = c_x(as.matrix(c(1, 2, 3)), 0, 2, 1, 1, "uniform")
  sol = matrix(c(0.083333333, 0.083333333), nrow=2)
  expect_equal(sx, sol)
})
